
module.exports = function(RED) {
    function GetTagValue(config) {
		//var valorDesDePython = "Encara no";
        RED.nodes.createNode(this,config);
        var node = this;
        
		node.plc = RED.nodes.getNode(config.server);
        var host = node.plc.host;
		var port = node.plc.port;
		var nodeName = config.name;
		console.log(nodeName + " >> Host: "+host+", Port: "+port);
			
        node.on('input', function(msg) {
			var globalContext = this.context().global;
            var myos = globalContext.get('osModule');
			var pythonshell = globalContext.get('PythonShell');
			let {PythonShell} = pythonshell;
			
			var tagID = config.tagID;
			console.log("tagID: " + tagID + " at " + nodeName + " >> Host: "+host+", Port: "+port);
			
			let options = {
			  mode: 'text',
			  pythonPath: '/usr/bin/python3',
			  pythonOptions: ['-u'], // get print results in real-time
			  scriptPath: '/home/jordi/Documents/electronics.cat/clients/johnson/python',
			  args: [host,port,tagID]
			};
			let pyshell = new PythonShell('var_opc-ua.py',options);
			// sends a message to the Python script via stdin
			pyshell.send('Missatge tramès des de Node.js per stdin');
			pyshell.on('message', function (message) {
			  // received a message sent from the Python script (a simple "print" statement)
			  console.log(message);
			  //valorDesDePython = message;
			  node.send({"payload": message});
			  if(message != "error")
				node.status({fill:"green",shape:"dot",text:"tag found"});
			  else
				node.status({fill:"red",shape:"ring",text:"tag not found"});
			});
			// end the input stream and allow the process to exit
			pyshell.end(function (err,code,signal) {
			  if (err) throw err;
			  console.log('The exit code was: ' + code);
			  console.log('The exit signal was: ' + signal);
			  console.log('PythonShell finished!');
			  //node.send({"payload": "A10"});
			});			

            //console.log("Hola des de dins de lower-case.js"); // Va al terminal d'execució
            //console.log("valorDesDePython: ",valorDesDePython); // Va un cop endarrerit

            //msg.payload = "Hola " + msg.payload.toLowerCase() + ", OS: " + myos.platform() + ". Des de Python: " + valorDesDePython;
            //msg.payload = "Des d'OPC-UA via Python: " + valorDesDePython;
            //node.send(msg);
        });
    }
    RED.nodes.registerType("get-tag-value",GetTagValue);
}


