import { AddressSpace, BaseNode, UAObject, UAServerCapabilities, UAVariable } from "node-opcua-address-space";
import { AggregateConfigurationOptionsEx } from "./interval";
export declare function createHistoryServerCapabilities(addressSpace: AddressSpace, serverCapabilities: UAServerCapabilities): UAObject;
export declare type AggregateFunctionName = "AnnotationCount" | "Average" | "Count" | "Delta" | "DeltaBounds" | "DurationBad" | "DurationGood" | "DurationInStateNonZero" | "DurationInStateZero" | "EndBound" | "Interpolative" | "Maximum" | "Maximum2" | "MaximumActualTime" | "MaximumActualTime2" | "Minimum" | "Minimum2" | "MinimumActualTime" | "MinimumActualTime2" | "NumberOfTransitions" | "PercentBad" | "PercentGood" | "Range" | "Range2" | "StandardDeviationPopulation" | "StandardDeviationSample" | "Start" | "StartBound" | "TimeAverage" | "TimeAverage2" | "Total" | "Total2" | "VariancePopulation" | "VarianceSample" | "WorstQuality" | "WorstQuality2";
export declare enum AggregateFunction {
    AnnotationCount = 2351,
    Average = 2342,
    Count = 2352,
    Delta = 2359,
    DeltaBounds = 11507,
    DurationBad = 2361,
    DurationGood = 2360,
    DurationInStateNonZero = 11308,
    DurationInStateZero = 2358,
    EndBound = 11506,
    Interpolative = 2341,
    Maximum = 2347,
    Maximum2 = 11287,
    MaximumActualTime = 2349,
    MaximumActualTime2 = 11306,
    Minimum = 2346,
    Minimum2 = 11286,
    MinimumActualTime = 2348,
    MinimumActualTime2 = 11305,
    NumberOfTransitions = 2355,
    PercentBad = 2363,
    PercentGood = 2362,
    Range = 2350,
    Range2 = 11288,
    StandardDeviationPopulation = 11427,
    StandardDeviationSample = 11426,
    Start = 2357,
    StartBound = 11505,
    TimeAverage = 2343,
    TimeAverage2 = 11285,
    Total = 2344,
    Total2 = 11304,
    VariancePopulation = 11429,
    VarianceSample = 11428,
    WorstQuality = 2364,
    WorstQuality2 = 11292
}
export declare function addAggregateSupport(addressSpace: AddressSpace): void;
export declare function installAggregateConfigurationOptions(node: UAVariable, options: AggregateConfigurationOptionsEx): void;
export declare function getAggregateConfiguration(node: BaseNode): AggregateConfigurationOptionsEx;
