
import {Figura} from './Figura.js';

class Rectangulo extends Figura {
	constructor() {
		super();
	}

	connectedCallback() {
		this.color = this.getAttribute("color");		
		this.base = this.getAttribute("base");		
		this.altura = this.getAttribute("altura");		
		this.render();
	}

	static get observedAttributes() { return ['color']; }

	attributeChangedCallback(name, oldValue, newValue) {
	  if (oldValue) {
		  switch (name) {
			case 'color':
			  this.color = newValue;
			  this.render();
			  break;
		  }
	  }
	}

	area() {
		return this.base * this.altura;
	}

	render() {
		let contenido = `
		  <svg height="${this.altura}">
			<rect x="0" y="0"
				  width="${this.base}" height="${this.altura}"
				  style="fill:${this.color}" />
			</svg>
		`;

		this.shadowRoot.innerHTML = contenido;
	}
}

customElements.define('wg-rectangulo', Rectangulo);

export {Rectangulo};	

