
// http://node-opcua.github.io
// https://github.com/node-opcua/node-opcua/blob/master/documentation/creating_a_client.md

/*global require,console,setTimeout */
var opcua = require("node-opcua");
var async = require("async");


var client_options = {
	applicationName: "Minimal client"
};

var client = new opcua.OPCUAClient(client_options);
//var endpointUrl = "opc.tcp://" + require("os").hostname() + ":4334/UA/MyLittleServer";

var endpointUrl = "opc.tcp://192.168.254.119:4840";

var the_session;


async.series([

    // step 1 : connect to
    function(continueExecution)  {
        client.connect(endpointUrl, function (err) {
			continueExecution(err);
		});
    },
    // step 2 : createSession
    function(continueExecution) {
        client.createSession( function(err, session) {
			the_session = session; 
			continueExecution(err);
		});
    },
    // step 3 : read a variable with readVariableValue
    function(continueExecution) {
        the_session.readVariableValue('ns=3;s="DB1002 - LGF_CosinusCI_3"."cosinusValues"', function(err, dataValue) {
			console.log("FanSpeed = " , dataValue.value.value);
            continueExecution(err);
        });
    },
    // close session
    function(continueExecution) {
        the_session.close(function(err){
            continueExecution(err);
        });
    }

],
function(err) {
    if (err) {
        console.log("Failure ", err);
    }
    client.disconnect(function(){});
}) ;
		